DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Toast - Stack

The DevExtreme JavaScript Toast components can stack multiple notifications. Use the notify(message, stack) or notify(options, stack) method to display stacked messages.

These methods use a stack object that has the following structure: {position, direction}.

Backend API
let id = 1; let direction = 'up-push'; let position = 'bottom center'; $(() => { $('#create').dxButton({ text: 'Show', width: '48%', onClick() { DevExpress.ui.notify({ message: `Toast ${id}`, height: 45, width: 150, minWidth: 150, type: types[Math.floor(Math.random() * 4)], displayTime: 3500, animation: { show: { type: 'fade', duration: 400, from: 0, to: 1, }, hide: { type: 'fade', duration: 40, to: 0 }, }, }, { position, direction, }); id += 1; }, }); $('#hide').dxButton({ text: 'Hide all', width: '48%', onClick() { DevExpress.ui.hideToasts(); }, }); $('#radioGroup').dxRadioGroup({ layout: 'horizontal', value: 'predefined', items: ['predefined', 'coordinates'], onValueChanged: ({ value }) => { const predefinedSelected = value === 'predefined'; positionSelect.option('visible', predefinedSelected); topNumberBox.option('visible', !predefinedSelected); leftNumberBox.option('visible', !predefinedSelected); bottomNumberBox.option('visible', !predefinedSelected); rightNumberBox.option('visible', !predefinedSelected); position = predefinedSelected ? positionSelect.option('value') : { top: topNumberBox.option('value') || undefined, left: leftNumberBox.option('value') || undefined, bottom: bottomNumberBox.option('value') || undefined, right: rightNumberBox.option('value') || undefined, }; }, }); const positionSelect = $('#position').dxSelectBox({ items: positions, inputAttr: { 'aria-label': 'Position' }, value: position, onSelectionChanged: ({ selectedItem }) => { position = selectedItem; }, }).dxSelectBox('instance'); $('#direction').dxSelectBox({ items: directions, inputAttr: { 'aria-label': 'Direction' }, value: direction, onSelectionChanged: ({ selectedItem }) => { direction = selectedItem; }, }); const numberBoxValueChange = (value, pos, componentToDisable) => { position[pos] = value || undefined; componentToDisable.option('disabled', !!value); }; const commonNumberBoxOptions = { value: '', width: '48%', visible: false, valueChangeEvent: 'keyup', }; const topNumberBox = $('#positionTop').dxNumberBox({ ...commonNumberBoxOptions, placeholder: 'top', inputAttr: { 'aria-label': 'Position Top' }, onValueChanged: ({ value }) => numberBoxValueChange(value, 'top', bottomNumberBox), }).dxNumberBox('instance'); const bottomNumberBox = $('#positionBottom').dxNumberBox({ ...commonNumberBoxOptions, placeholder: 'bottom', inputAttr: { 'aria-label': 'Position Bottom' }, onValueChanged: ({ value }) => numberBoxValueChange(value, 'bottom', topNumberBox), }).dxNumberBox('instance'); const leftNumberBox = $('#positionLeft').dxNumberBox({ ...commonNumberBoxOptions, placeholder: 'left', inputAttr: { 'aria-label': 'Position Left' }, onValueChanged: ({ value }) => numberBoxValueChange(value, 'left', rightNumberBox), }).dxNumberBox('instance'); const rightNumberBox = $('#positionRight').dxNumberBox({ ...commonNumberBoxOptions, placeholder: 'right', inputAttr: { 'aria-label': 'Position Right' }, onValueChanged: ({ value }) => numberBoxValueChange(value, 'right', leftNumberBox), }).dxNumberBox('instance'); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.3"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="data.js"></script> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="options"> <div>Position</div> <div id="radioGroup"></div> <div id="position"></div> <div class="section"> <div id="positionTop"></div> <div id="positionBottom"></div> </div> <div class="section"> <div id="positionLeft"></div> <div id="positionRight"></div> </div> <div>Direction</div> <div id="direction"></div> <div class="section"> <div id="create"></div> <div id="hide"></div> </div> </div> </div> </body> </html>
.options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); position: absolute; right: 0; top: 0; width: 260px; display: flex; flex-direction: column; gap: 5px; } .section { width: 100%; display: flex; justify-content: space-between; }
const directions = [ 'down-push', 'down-stack', 'up-push', 'up-stack', 'left-push', 'left-stack', 'right-push', 'right-stack', ]; const positions = [ 'top left', 'top center', 'top right', 'bottom left', 'bottom center', 'bottom right', 'left center', 'center', 'right center', ]; const types = ['error', 'info', 'success', 'warning'];

Specify Position

You can set the position field to a string (select 'predefined' in the radio group) or an object (select 'coordinates' in the radio group). Note that if you use coordinates for the position field, you need to specify one vertical and one horizontal coordinate only. For example, if you specify 'top', the demo disables the 'bottom' field, and vice versa.

Specify Direction

The direction field specifies two options: which way the notification stack grows and whether new notifications appear at the end or at the beginning of the line. For this reason, the field's pull-down menu choices show pairs of values such as 'up-push' and 'up-stack'.

  • 'up-push'
    New toasts push the previous toasts upwards.

  • 'up-stack'
    Toasts stack on top of each other.

Hide Toasts

To hide all toast messages, use the hideToasts method.

import React, { useCallback, useState } from 'react';
import Button from 'devextreme-react/button';
import RadioGroup from 'devextreme-react/radio-group';
import SelectBox from 'devextreme-react/select-box';
import type { SelectBoxTypes } from 'devextreme-react/select-box';
import NumberBox from 'devextreme-react/number-box';
import Notify from 'devextreme/ui/notify';
import HideToasts from 'devextreme/ui/toast/hide_toasts';
import type { NotifyStack } from './types.ts';
import {
directions,
positions,
types,
radioGroupItems,
positionTopLabel,
directionLabel,
positionBottomLabel,
positionLeftLabel,
positionRightLabel,
positionLabel,
} from './data.ts';
function App() {
const [id, setId] = useState<number>(1);
const [isPredefined, setIsPredefined] = useState<boolean>(true);
const [predefinedPosition, setPredefinedPosition] = useState<NotifyStack['position']>('bottom center');
const [coordinatePosition, setCoordinatePosition] = useState<NotifyStack['position']>({
top: undefined,
left: undefined,
bottom: undefined,
right: undefined,
});
const [direction, setDirection] = useState<NotifyStack['direction']>('up-push');
const topNumberBoxValueChanged = useCallback(
(top: number | undefined): void => setCoordinatePosition({ ...coordinatePosition, top }),
[coordinatePosition],
);
const bottomNumberBoxValueChanged = useCallback(
(bottom: number | undefined): void => setCoordinatePosition({ ...coordinatePosition, bottom }),
[coordinatePosition],
);
const leftNumberBoxValueChanged = useCallback(
(left: number | undefined): void => setCoordinatePosition({ ...coordinatePosition, left }),
[coordinatePosition],
);
const rightNumberBoxValueChanged = useCallback(
(right: number | undefined): void => setCoordinatePosition({ ...coordinatePosition, right }),
[coordinatePosition],
);
const show = useCallback(() => {
const position: NotifyStack['position'] = isPredefined ? predefinedPosition : coordinatePosition;
Notify({
message: `Toast ${id}`,
height: 45,
width: 150,
minWidth: 150,
type: types[Math.floor(Math.random() * 4)],
displayTime: 3500,
animation: {
show: {
type: 'fade', duration: 400, from: 0, to: 1,
},
hide: { type: 'fade', duration: 40, to: 0 },
},
}, {
position,
direction,
});
setId(id + 1);
}, [id, isPredefined, predefinedPosition, coordinatePosition, direction]);
return (
<>
<div className='options'>
<div>Position</div>
<RadioGroup
layout='horizontal'
defaultValue='predefined'
items={radioGroupItems}
onValueChange={(value: string): void => setIsPredefined(value === 'predefined')} />
<SelectBox
items={positions}
value={predefinedPosition}
inputAttr={positionLabel}
onSelectionChanged={({ selectedItem }: SelectBoxTypes.SelectionChangedEvent): void => setPredefinedPosition(selectedItem)}
visible={isPredefined} />
<div className='section'>
<NumberBox
visible={!isPredefined}
placeholder='top'
defaultValue={undefined}
valueChangeEvent='keyup'
disabled={!!coordinatePosition.bottom}
inputAttr={positionTopLabel}
onValueChange={topNumberBoxValueChanged} />
<NumberBox
visible={!isPredefined}
placeholder='bottom'
defaultValue={undefined}
valueChangeEvent='keyup'
inputAttr={positionBottomLabel}
disabled={!!coordinatePosition.top}
onValueChange={bottomNumberBoxValueChanged} />
</div>
<div className='section'>
<NumberBox
visible={!isPredefined}
placeholder='left'
defaultValue={undefined}
valueChangeEvent='keyup'
inputAttr={positionLeftLabel}
disabled={!!coordinatePosition.right}
onValueChange={leftNumberBoxValueChanged} />
<NumberBox
visible={!isPredefined}
placeholder='right'
defaultValue={undefined}
valueChangeEvent='keyup'
inputAttr={positionRightLabel}
disabled={!!coordinatePosition.left}
onValueChange={rightNumberBoxValueChanged} />
</div>
<div>Direction</div>
<SelectBox
items={directions}
inputAttr={directionLabel}
value={direction}
onSelectionChanged={({ selectedItem }: SelectBoxTypes.SelectionChangedEvent): void => setDirection(selectedItem)} />
<div className='section'>
<Button text='Show' width='48%' onClick={show} />
<Button text='Hide all' width='48%' onClick={() => HideToasts()} />
</div>
</div>
</>
);
}
export default App;
import React, { useCallback, useState } from 'react';
import Button from 'devextreme-react/button';
import RadioGroup from 'devextreme-react/radio-group';
import SelectBox from 'devextreme-react/select-box';
import NumberBox from 'devextreme-react/number-box';
import Notify from 'devextreme/ui/notify';
import HideToasts from 'devextreme/ui/toast/hide_toasts';
import {
directions,
positions,
types,
radioGroupItems,
positionTopLabel,
directionLabel,
positionBottomLabel,
positionLeftLabel,
positionRightLabel,
positionLabel,
} from './data.js';
function App() {
const [id, setId] = useState(1);
const [isPredefined, setIsPredefined] = useState(true);
const [predefinedPosition, setPredefinedPosition] = useState('bottom center');
const [coordinatePosition, setCoordinatePosition] = useState({
top: undefined,
left: undefined,
bottom: undefined,
right: undefined,
});
const [direction, setDirection] = useState('up-push');
const topNumberBoxValueChanged = useCallback(
(top) => setCoordinatePosition({ ...coordinatePosition, top }),
[coordinatePosition],
);
const bottomNumberBoxValueChanged = useCallback(
(bottom) => setCoordinatePosition({ ...coordinatePosition, bottom }),
[coordinatePosition],
);
const leftNumberBoxValueChanged = useCallback(
(left) => setCoordinatePosition({ ...coordinatePosition, left }),
[coordinatePosition],
);
const rightNumberBoxValueChanged = useCallback(
(right) => setCoordinatePosition({ ...coordinatePosition, right }),
[coordinatePosition],
);
const show = useCallback(() => {
const position = isPredefined ? predefinedPosition : coordinatePosition;
Notify(
{
message: `Toast ${id}`,
height: 45,
width: 150,
minWidth: 150,
type: types[Math.floor(Math.random() * 4)],
displayTime: 3500,
animation: {
show: {
type: 'fade',
duration: 400,
from: 0,
to: 1,
},
hide: { type: 'fade', duration: 40, to: 0 },
},
},
{
position,
direction,
},
);
setId(id + 1);
}, [id, isPredefined, predefinedPosition, coordinatePosition, direction]);
return (
<>
<div className="options">
<div>Position</div>
<RadioGroup
layout="horizontal"
defaultValue="predefined"
items={radioGroupItems}
onValueChange={(value) => setIsPredefined(value === 'predefined')}
/>
<SelectBox
items={positions}
value={predefinedPosition}
inputAttr={positionLabel}
onSelectionChanged={({ selectedItem }) => setPredefinedPosition(selectedItem)}
visible={isPredefined}
/>
<div className="section">
<NumberBox
visible={!isPredefined}
placeholder="top"
defaultValue={undefined}
valueChangeEvent="keyup"
disabled={!!coordinatePosition.bottom}
inputAttr={positionTopLabel}
onValueChange={topNumberBoxValueChanged}
/>
<NumberBox
visible={!isPredefined}
placeholder="bottom"
defaultValue={undefined}
valueChangeEvent="keyup"
inputAttr={positionBottomLabel}
disabled={!!coordinatePosition.top}
onValueChange={bottomNumberBoxValueChanged}
/>
</div>
<div className="section">
<NumberBox
visible={!isPredefined}
placeholder="left"
defaultValue={undefined}
valueChangeEvent="keyup"
inputAttr={positionLeftLabel}
disabled={!!coordinatePosition.right}
onValueChange={leftNumberBoxValueChanged}
/>
<NumberBox
visible={!isPredefined}
placeholder="right"
defaultValue={undefined}
valueChangeEvent="keyup"
inputAttr={positionRightLabel}
disabled={!!coordinatePosition.left}
onValueChange={rightNumberBoxValueChanged}
/>
</div>
<div>Direction</div>
<SelectBox
items={directions}
inputAttr={directionLabel}
value={direction}
onSelectionChanged={({ selectedItem }) => setDirection(selectedItem)}
/>
<div className="section">
<Button
text="Show"
width="48%"
onClick={show}
/>
<Button
text="Hide all"
width="48%"
onClick={() => HideToasts()}
/>
</div>
</div>
</>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { ToastType } from 'devextreme/ui/toast';
import type { NotifyStack } from './types.ts';
export const directions: NotifyStack['direction'][] = [
'down-push',
'down-stack',
'up-push',
'up-stack',
'left-push',
'left-stack',
'right-push',
'right-stack',
];
export const positions: NotifyStack['position'][] = [
'top left',
'top center',
'top right',
'bottom left',
'bottom center',
'bottom right',
'left center',
'center',
'right center',
];
export const types: ToastType[] = ['error', 'info', 'success', 'warning'];
export const radioGroupItems: string[] = ['predefined', 'coordinates'];
export const positionTopLabel = { 'aria-label': 'Position Top' };
export const positionBottomLabel = { 'aria-label': 'Position Bottom' };
export const positionLeftLabel = { 'aria-label': 'Position Left' };
export const positionRightLabel = { 'aria-label': 'Position Right' };
export const directionLabel = { 'aria-label': 'Direction' };
export const positionLabel = { 'aria-label': 'Position' };
import Notify from 'devextreme/ui/notify';
export type NotifyStack = (typeof Notify)['arguments'][1];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const directions = [
'down-push',
'down-stack',
'up-push',
'up-stack',
'left-push',
'left-stack',
'right-push',
'right-stack',
];
export const positions = [
'top left',
'top center',
'top right',
'bottom left',
'bottom center',
'bottom right',
'left center',
'center',
'right center',
];
export const types = ['error', 'info', 'success', 'warning'];
export const radioGroupItems = ['predefined', 'coordinates'];
export const positionTopLabel = { 'aria-label': 'Position Top' };
export const positionBottomLabel = { 'aria-label': 'Position Bottom' };
export const positionLeftLabel = { 'aria-label': 'Position Left' };
export const positionRightLabel = { 'aria-label': 'Position Right' };
export const directionLabel = { 'aria-label': 'Direction' };
export const positionLabel = { 'aria-label': 'Position' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: absolute;
right: 0;
top: 0;
width: 260px;
display: flex;
flex-direction: column;
gap: 5px;
}
.section {
width: 100%;
display: flex;
justify-content: space-between;
}

<div class="options">
<div>Position</div>
<dx-radio-group
layout="horizontal"
[items]="['predefined', 'coordinates']"
value="predefined"
(onValueChanged)="radioGroupValueChanged($event)"
>
</dx-radio-group>
<dx-select-box
[items]="positions"
[inputAttr]="{ 'aria-label': 'Position' }"
[(value)]="predefinedPosition"
[visible]="isPredefined"
>
</dx-select-box>
<div class="section">
<dx-number-box
[visible]="!isPredefined"
placeholder="top"
[(value)]="coordinatePosition.top"
width="48%"
valueChangeEvent="keyup"
[disabled]="!!coordinatePosition.bottom"
[inputAttr]="{ 'aria-label': 'Position Top' }"
>
</dx-number-box>
<dx-number-box
[visible]="!isPredefined"
placeholder="bottom"
[(value)]="coordinatePosition.bottom"
width="48%"
valueChangeEvent="keyup"
[disabled]="!!coordinatePosition.top"
[inputAttr]="{ 'aria-label': 'Position Bottom' }"
>
</dx-number-box>
</div>
<div class="section">
<dx-number-box
[visible]="!isPredefined"
placeholder="left"
[(value)]="coordinatePosition.left"
width="48%"
valueChangeEvent="keyup"
[disabled]="!!coordinatePosition.right"
[inputAttr]="{ 'aria-label': 'Position Left' }"
>
</dx-number-box>
<dx-number-box
[visible]="!isPredefined"
placeholder="right"
[(value)]="coordinatePosition.right"
width="48%"
valueChangeEvent="keyup"
[disabled]="!!coordinatePosition.left"
[inputAttr]="{ 'aria-label': 'Position Right' }"
>
</dx-number-box>
</div>
<div>Direction</div>
<dx-select-box
[items]="directions"
[(value)]="direction"
[inputAttr]="{ 'aria-label': 'Direction' }"
>
</dx-select-box>
<div class="section">
<dx-button text="Show" width="48%" (onClick)="show()"></dx-button>
<dx-button text="Hide all" width="48%" (onClick)="hideAll()"></dx-button>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import {
DxButtonModule,
DxRadioGroupModule,
DxSelectBoxModule,
DxNumberBoxModule,
} from 'devextreme-angular';
import notify from 'devextreme/ui/notify';
import hideToasts from 'devextreme/ui/toast/hide_toasts';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
type Position = Parameters<typeof notify>[1]['position'];
type Direction = Parameters<typeof notify>[1]['direction'];
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxButtonModule,
DxRadioGroupModule,
DxSelectBoxModule,
DxNumberBoxModule,
],
})
export class AppComponent {
types: string[] = ['error', 'info', 'success', 'warning'];
positions: Position[] = [
'top left', 'top center', 'top right',
'bottom left', 'bottom center', 'bottom right',
'left center', 'center', 'right center',
];
directions: Direction[] = [
'down-push', 'down-stack', 'up-push', 'up-stack',
'left-push', 'left-stack', 'right-push', 'right-stack',
];
id = 1;
isPredefined = true;
predefinedPosition: Position = 'bottom center';
coordinatePosition = {
top: undefined,
bottom: undefined,
left: undefined,
right: undefined,
};
direction: Direction = 'up-push';
show() {
const position = this.isPredefined ? this.predefinedPosition : this.coordinatePosition;
const direction = this.direction;
notify({
message: `Toast ${this.id}`,
height: 45,
width: 150,
minWidth: 150,
type: this.types[Math.floor(Math.random() * 4)],
displayTime: 3500,
animation: {
show: {
type: 'fade', duration: 400, from: 0, to: 1,
},
hide: { type: 'fade', duration: 40, to: 0 },
},
},
{ position, direction });
this.id += 1;
}
hideAll() {
hideToasts();
}
radioGroupValueChanged({ value }) {
this.isPredefined = value === 'predefined';
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: absolute;
right: 0;
top: 0;
width: 260px;
display: flex;
flex-direction: column;
gap: 5px;
}
.section {
width: 100%;
display: flex;
justify-content: space-between;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "21.2.17"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div>
<div class="options">
<div>Position</div>
<DxRadioGroup
layout="horizontal"
:items="['predefined', 'coordinates']"
value="predefined"
@value-changed="radioGroupValueChanged($event)"
/>
<DxSelectBox
:items="positions"
:input-attr="{ 'aria-label': 'Position' }"
v-model:value="predefinedPosition"
:visible="isPredefined"
/>
<div class="section">
<DxNumberBox
:visible="!isPredefined"
placeholder="top"
v-model:value="coordinatePosition.top"
width="48%"
value-change-event="keyup"
:disabled="!!coordinatePosition.bottom"
:input-attr="{ 'aria-label': 'Position Top' }"
/>
<DxNumberBox
:visible="!isPredefined"
placeholder="bottom"
v-model:value="coordinatePosition.bottom"
width="48%"
value-change-event="keyup"
:disabled="!!coordinatePosition.top"
:input-attr="{ 'aria-label': 'Position Bottom' }"
/>
</div>
<div class="section">
<DxNumberBox
:visible="!isPredefined"
placeholder="left"
v-model:value="coordinatePosition.left"
width="48%"
value-change-event="keyup"
:disabled="!!coordinatePosition.right"
:input-attr="{ 'aria-label': 'Position Left' }"
/>
<DxNumberBox
:visible="!isPredefined"
placeholder="right"
v-model:value="coordinatePosition.right"
width="48%"
value-change-event="keyup"
:disabled="!!coordinatePosition.left"
:input-attr="{ 'aria-label': 'Position Right' }"
/>
</div>
<div>Direction</div>
<DxSelectBox
:items="directions"
:input-attr="{ 'aria-label': 'Direction' }"
v-model:value="direction"
/>
<div class="section">
<DxButton
text="Show"
width="48%"
@click="show()"
/>
<DxButton
text="Hide all"
width="48%"
@click="hideAll()"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxButton from 'devextreme-vue/button';
import DxRadioGroup, { type DxRadioGroupTypes } from 'devextreme-vue/radio-group';
import DxSelectBox from 'devextreme-vue/select-box';
import DxNumberBox from 'devextreme-vue/number-box';
import notify from 'devextreme/ui/notify';
import hideToasts from 'devextreme/ui/toast/hide_toasts';
const types = ['error', 'info', 'success', 'warning'];
const positions = [
'top left', 'top center', 'top right',
'bottom left', 'bottom center', 'bottom right',
'left center', 'center', 'right center',
];
const directions = [
'down-push', 'down-stack', 'up-push', 'up-stack',
'left-push', 'left-stack', 'right-push', 'right-stack',
];
let id = 1;
const isPredefined = ref(true);
const predefinedPosition = ref<typeof positions[number]>('bottom center');
const coordinatePosition = ref({
top: undefined,
bottom: undefined,
left: undefined,
right: undefined,
});
const direction = ref<typeof directions[number]>('up-push');
function show() {
const newPosition = isPredefined.value ? predefinedPosition.value : coordinatePosition.value;
const newDirection = direction.value;
notify({
message: `Toast ${id}`,
height: 45,
width: 150,
minWidth: 150,
type: types[Math.floor(Math.random() * 4)],
displayTime: 3500,
animation: {
show: {
type: 'fade', duration: 400, from: 0, to: 1,
},
hide: { type: 'fade', duration: 40, to: 0 },
},
},
{ position: newPosition as any, direction: newDirection as any });
id += 1;
}
function hideAll() {
hideToasts();
}
function radioGroupValueChanged({ value }: DxRadioGroupTypes.ValueChangedEvent) {
isPredefined.value = value === 'predefined';
}
</script>
<style>
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: absolute;
right: 0;
top: 0;
width: 260px;
display: flex;
flex-direction: column;
gap: 5px;
}
.section {
width: 100%;
display: flex;
justify-content: space-between;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>